#!/usr/bin/env python
import sys, os, math, string, re, gzip, urllib, shutil, Bio
import cStringIO
from numpy import *
import AnalyzeXYdata


def Compute_K( RawRSA_vs_HP_data, NumberOfBins, NumberOfAminoAcids, PopSize, MutationRate ):
    """ With or Without Cys & Met"""
    if NumberOfAminoAcids == 20:
        dist_matrix = AnalyzeXYdata.MakeRelativeFrequencies( RawRSA_vs_HP_data, NumberOfBins )
    elif NumberOfAminoAcids == 18:
        dist_matrix = AnalyzeXYdata.MakeRelativeFrequenciesWithoutCysMet( RawRSA_vs_HP_data, NumberOfBins )
    
    """Here, form matrix of fitness values"""
    fitness_matrix = zeros([NumberOfBins,NumberOfAminoAcids],float)
    for i in range( NumberOfBins ):
        for j in range(NumberOfAminoAcids):
            fitness_matrix[i][j] = pow(dist_matrix[i][j], 1/float(2*(PopSize - 1)))
    print "Fitness Matrix:", fitness_matrix

    print '\n'
    
    """Here, form a matrix of fixation probabilities for each bin"""
    fixation_matrix = zeros([NumberOfBins,NumberOfAminoAcids,NumberOfAminoAcids], float )
    for i in range( NumberOfBins ):
        for j in range( NumberOfAminoAcids ):
            for k in range( NumberOfAminoAcids ):
                if not j == k:
                    if not dist_matrix[i][j] == dist_matrix[i][k]:
                        fixation_matrix[i][j][k] = (1 - pow( ( fitness_matrix[i][j] / fitness_matrix[i][k] ), 2 )) / (1 - pow( ( fitness_matrix[i][j] / fitness_matrix[i][k] ), float(2*PopSize) ))
                    else:
                        fixation_matrix[i][j][k] = 1/PopSize
                    #fixation_matrix[i][j][k] = (1 - pow( ( fitness_matrix[i][j] / fitness_matrix[i][k] ), 2 )) / (1 - (dist_matrix[i][j]/dist_matrix[i][k]) )
                else:
                    fixation_matrix[i][j][k] = 0.0


    """Now, compute evol rate for each bin"""
    K = []
    for i in range(NumberOfBins):
        K_dummy = 0.0
        distXfix_sum = 0.0
        for j in range(NumberOfAminoAcids):
            fixation_sum = 0.0
            for k in range(NumberOfAminoAcids):
                fixation_sum = fixation_sum + fixation_matrix[i][j][k]
            distXfix_dummy = dist_matrix[i][j] * ( fixation_sum )
            distXfix_sum = distXfix_sum + distXfix_dummy
        K_dummy = PopSize * MutationRate * distXfix_sum
        K.append(K_dummy)
    print K
    return K


    
    
    
    
    
    
    
