#!/usr/bin/env python
import sys, os, math, string, re, gzip, urllib, shutil, Bio
from numpy import *




def Compute_K( PopSize, MutationRate ):
    OrderedHPs = [str(-1.01), str(-0.99), str(-0.77), str(-0.64), str(-0.6), str(-0.22), str(-0.04), str(0.0), str(0.13), str(0.26), str(0.31), str(0.75), str(0.96), str(1.22), str(1.23), str(1.54), str(1.7), str(1.79), str(1.8), str(2.25)]
#    B = [-4.5, -4.0, -3.5, -3.0, -2.5, -2.0, -1.5, -1.0, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5]
    B = []
    dummy = -4.5
    next = -4.5
    for i in range(91):
        dummy = round( next, 1)
        print dummy
        B.append( str(dummy) )
        next = next + .1
    print B
    NumberOfBins = len(B)
    """Compute Distribution Matrix:"""
    dist_matrix = zeros([NumberOfBins,20], float)
    for i in range(NumberOfBins):
        row_sum = 0.0
        for j in range(20):
            dist_matrix[i][j] = math.exp(-float(B[i]) * float(OrderedHPs[j]))
            row_sum = row_sum + dist_matrix[i][j]
        for j in range(20):
            dist_matrix[i][j] = dist_matrix[i][j]/row_sum
    print "Distribution Matrix:", '\n', dist_matrix

    """Compute Fitness Matrix:"""
    fitness_matrix = zeros([NumberOfBins,20],float)
    for i in range( NumberOfBins ):
        for j in range( 20 ):
            fitness_matrix[i][j] = pow(dist_matrix[i][j], 1/float(2*(PopSize - 1)))
    print "Fitness Matrix:", '\n', fitness_matrix
    print "PopSize", PopSize
    """Compute matrix of fixation probabilities for each bin"""
    fixation_matrix = zeros([NumberOfBins,20,20], float )
    for i in range( NumberOfBins ):
        for j in range( 20 ):
            for k in range( 20 ):
                if not j == k:
                    if not dist_matrix[i][j] == dist_matrix[i][k]:
                        fixation_matrix[i][j][k] = (1 - pow( ( fitness_matrix[i][j] / fitness_matrix[i][k] ), 2 )) / (1 - pow( ( fitness_matrix[i][j] / fitness_matrix[i][k] ), float(2*PopSize) ))
                    else:
                        fixation_matrix[i][j][k] = 1.0/PopSize
                else:
                    fixation_matrix[i][j][k] = 0.0

    
    """Now, compute evolutionary rate for each bin"""
    K = []
    for i in range(NumberOfBins):
        K_dummy = 0.0
        distXfix_sum = 0.0
        for j in range(20):
            fixation_sum = 0.0
            for k in range(20):
                fixation_sum = fixation_sum + fixation_matrix[i][j][k]
            distXfix_dummy = dist_matrix[i][j] * ( fixation_sum )
            distXfix_sum = distXfix_sum + distXfix_dummy
        K_dummy = PopSize * MutationRate * distXfix_sum
        K.append(K_dummy)
    print K
    print "B:"
    print "c(",
    for i in range( len(B)-1 ):
        print str(B[i]) + ",",
    print str(B[-1]),
    print ")"
    return K
    
    
    
    
    
    
    
    
    
    
    
    
    