#require(Hmisc)
pdf( "labeled_slope-int.pdf", width=7, height=7, useDingbats=FALSE )
par( mai=c(0.70, 0.70, 0.1, 0.05), mgp=c(2.25, 0.95,0), tck=-0.02 )
#par( mai=c(0.65, 0.65, 0.2, 0.05), mgp=c(2, 0.7, 0), tck=-0.03 )

regs <- data.frame(read.table( "cor_test.txt", header=TRUE ))
attach(regs)
names(regs)

matrix <- cbind(lm_slope, lm_intercept )
plot(matrix, pch=20, axes=FALSE, xlim=c(-2,2), ylim=c(0,2), xlab="Slope", ylab="Intercept",cex.lab=1.25 )
axis( 1, at=c(-2,-1,0,1,2), labels=c('-2','-1','0','1','2'), cex.axis=1.25 )
axis( 2, at=c(0,.5,1,1.5,2), labels=c('0', '0.5', '1.0', '1.5', '2.0'), cex.axis=1.25 )


text(matrix[90,1], matrix[90,2]+.05, "1GV3A")
#text(matrix[27,1]-.7, matrix[27,2]-.2, "1S4OA")
#text(matrix[94,1]-.3, matrix[94,2]-.25, "2GLFA")

text(matrix[61,1]-.45, matrix[61,2]+.007, "1JG8A")
text(matrix[28,1]+0.55, matrix[28,2]+.085, "1W85B")
text(matrix[55,1]+.15, matrix[55,2]+.3, "1QMVA")
text(matrix[150,1]+0.35, matrix[150,2]+0.09, "2C78A")


#segments(matrix[27,1]-.002, matrix[27,2]-.02,matrix[27,1]-.5, matrix[27,2]-.15,, lwd=2) #1S4OA
#segments(matrix[94,1]-.02, matrix[94,2]-.001,matrix[94,1]-.3, matrix[94,2]-.2, lwd=2) #2GLFA
segments(matrix[28,1]+.02, matrix[28,2]+.002,matrix[28,1]+0.35, matrix[28,2]+.07, lwd=2) #1W85B
segments(matrix[55,1]+.02, matrix[55,2]+.03, matrix[55,1]+.13, matrix[55,2]+.26, lwd=2 ) #1QMVA
segments(matrix[61,1]-.25, matrix[61,2]+.001, matrix[61,1]-.07, matrix[61,2], lwd=2 ) #1JG8A
segments(matrix[150,1]+0.165, matrix[150,2]+0.06,matrix[150,1]+0.04, matrix[150,2]+0.015, lwd=2) #2C78A

#for (i in 1:162) {
#	print(regs[i,1])
#	text(matrix[i,1], matrix[i,2], pdb[i])
#}

detach(regs)
dev.off()