require(lattice)
require(fields)

pdf( "RSAxAminoAcidxFreq_Surface_10bins_wout_MetCys_shading.pdf", width=7, height=6.5, useDingbats=FALSE )
d<-read.table("RSAvsHPvsRelFreq_10bins_WOutCysMet.txt", header=F)


names(d) <- c("x", "y", "z")
attach(d)
x #=.9-x
y #= 17 - y
z


tpsfit <- Tps(cbind(rev(y), x), z, scale.type="range")
tpsfit
#ngrid <- length(x); grid <- cbind(rep(x, ngrid), rep(x, rep(ngrid, ngrid)))
#ngrid <- length(x); grid <- cbind(x, y)
out.p <- predict.surface(tpsfit)# , grid)
surface(out.p, type="p", ylab="RSA", xlab="Amino Acid", zlab="Relative Freqency",
	ylim=c(0.0,0.9), xlim=c(0,19), zlim = c(0.0, 0.15),
	theta=-65,
	phi = 17,	
	ticktype = "detailed",
	nticks = c(5,3,4), add.legend =FALSE, 
	shade =.5, col=gray(.55),
	border=NA,
	#light.source=c(0,10,10) 
	aspect = c(1, 0.65)
	)
	#scales = list(arrows=FALSE),
	#col = grey(5/8))
	#col = grey(40:1 / 40))
	#col=terrain.colors(128))



detach(d)
dev.off()