
pdf( "lambdas_4_panes.pdf", width=9, height=9, useDingbats=FALSE )
#par( mai=c(0.65, 0.65, 0.1, 0.05), mgp=c(2, 0.5, 0), tck=-0.03 )


betas <- data.frame(read.table( "betas.txt", header = TRUE ))
RSA <- c( 0.05 , 0.15 , 0.25 , 0.35 , 0.45 , 0.55 , 0.65 , 0.75 , 0.85 , 0.95 ) # relative solvent accessibility
attach(betas)

split.screen(c(2,2))

screen(1)
i<-61
lambda <- betas[i,2:11]
plot( RSA, lambda, type= 'p', pch=20, col='black', xlim=c(0.0, 1.0), ylim=c(.2,1.1),axes=FALSE, xlab='RSA', ylab=expression(lambda))
abline( lm(unlist(lambda)~RSA), col='grey60', lty=2)
lm(unlist(lambda)~RSA)
mtext(expression(bold("A")), side=2, las=1, at=1.15, line = 2.3, cex=1.2)
axis( 1, at=c(0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0), c('0.0', '0.1', '0.2', '0.3', '0.4', '0.5', '0.6', '0.7', '0.8', '0.9', '1.0'), cex.axis=.95 )
axis( 2, at=c(.2,.5,.8,1.1), c('0.2', '0.5', '0.8', '1.1'), cex.axis=.95)
legend( "topright", c("1JG8A", expression(paste(rho, "=-0.9, ", italic(P), "<0.001")) ), pch=c(NA_integer_), col=c('black','black'), bty='n' )

screen(2)
i<-28
lambda <- betas[i,2:11]
plot( RSA, lambda, type= 'p', pch=20, col='black', xlim=c(0.0, 1.0), ylim=c(.2,1.1),axes=FALSE, xlab='RSA', ylab=expression(lambda))
abline( lm(unlist(lambda)~RSA), col='grey60', lty=2)
lm(unlist(lambda)~RSA)
mtext(expression(bold("B")), side=2, las=1, at=1.15, line = 2.3, cex=1.2)
axis( 1, at=c(0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0), c('0.0', '0.1', '0.2', '0.3', '0.4', '0.5', '0.6', '0.7', '0.8', '0.9', '1.0'), cex.axis=.95 )
axis( 2, at=c(.2,.5,.8,1.1), c('0.2', '0.5', '0.8', '1.1'), cex.axis=.95)
legend( "topright", c("1W85B", expression(paste(rho, "=-0.8, ", italic(P), "<0.01")) ), pch=c(NA_integer_), col=c('black','black'), bty='n' )



screen(3)
i<-55
lambda <- betas[i,2:11]
plot( RSA, lambda, type= 'p', pch=20, col='black', xlim=c(0.0, 1.0), ylim=c(.2,1.6),axes=FALSE, xlab='RSA', ylab=expression(lambda))
abline( lm(unlist(lambda)~RSA), col='grey60', lty=2)
lm(unlist(lambda)~RSA)
mtext(expression(bold("C")), side=2, las=1, at=1.7, line = 2.3, cex=1.2)
axis( 1, at=c(0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0), c('0.0', '0.1', '0.2', '0.3', '0.4', '0.5', '0.6', '0.7', '0.8', '0.9', '1.0'), cex.axis=.95 )
axis( 2, at=c(.2,.55,.9,1.25,1.6), c('0.2', '0.55', '0.9', '1.25', '1.6') )
legend( "topright", c("1QMVA", expression(paste(rho, "=-0.9, ", italic(P), "<0.001")) ), pch=c(NA_integer_), col=c('black','black'), bty='n' )

screen(4)
i<-150
lambda <- betas[i,2:11]
plot( RSA, lambda, type= 'p', pch=20, col='black', xlim=c(0.0, 1.0), ylim=c(.2,1.6), axes=FALSE, xlab='RSA', ylab=expression(lambda))
abline( lm(unlist(lambda)~RSA), col='grey60', lty=2)
lm(unlist(lambda)~RSA)
mtext(expression(bold("D")), side=2, las=1, at=1.7, line = 2.3, cex=1.2)
axis( 1, at=c(0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0), c('0.0', '0.1', '0.2', '0.3', '0.4', '0.5', '0.6', '0.7', '0.8', '0.9', '1.0'), cex.axis=.95 )
axis( 2, at=c(.2,.55,.9,1.25,1.6), c('0.2', '0.55', '0.9', '1.25', '1.6') )
#axis( 2, at=c(0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7), c('0.9', '1.0', '1.1', '1.2', '1.3', '1.4', '1.5', '1.6', '1.7'), cex.axis=.95 )
legend( "topright", c("2C78A", expression(paste(rho, "=-0.2, ", italic(P), "=0.61")) ), pch=c(NA_integer_), col=c('black','black'), bty='n' )



close.screen(all = TRUE)
dev.off()
detach(betas)