#!/usr/bin/env python
import sys, os, math, string, re, gzip, urllib, shutil, Bio
import cStringIO
from numpy import *


    #formAlignmentMatrix( '1qleA', 538 )
def formAlignmentMatrix( pdb, seq_len ):
    xmlfile = pdb + "_blast.xml"
    Alignment = []
    count = 0
    N = seq_len
    f = open( xmlfile,'rb')
    for line in f:
        if "<Hsp_query-from>" in line:
            #count = count + 1
            #if count % 100 == 0:
            #    print count, "hits down."
            currentLine = line
            currentLine = currentLine[currentLine.index(">")+1:]
            currentLine = currentLine[:currentLine.index("<")]
            startPosition = int(currentLine) - 1
            line = f.next()
            if not "<Hsp_query-to>" in line:
                print "Epic Fail Hsp_query-to"
            currentLine = line
            currentLine = currentLine[currentLine.index(">")+1:]
            currentLine = currentLine[:currentLine.index("<")]
            endPosition = int(currentLine) - 1
            for i in range(7):
                line = f.next()
            if not "<Hsp_gaps>" in line:
                print "Epic Fail gaps"
            currentLine = line
            currentLine = currentLine[currentLine.index(">")+1:]
            currentLine = currentLine[:currentLine.index("<")]
            gap = int(currentLine)
            for i in range(2):
                line = f.next()
            if not "<Hsp_qseq>" in line:
                print "Epic Fail Hsp_qseq"
            currentLine = line
            currentLine = currentLine[currentLine.index(">")+1:]
            currentLine = currentLine[:currentLine.index("<")]
            querySeq = currentLine
            cutResidues = []
            for i in range(len(querySeq)):
                if querySeq[i] == '-':
                    cutResidues.append(i)


            if gap == len(cutResidues):
                line = f.next()
                if not "<Hsp_hseq>" in line:
                    print "Epic Fail Hsp_hseq"
                currentLine = line
                #currentLine.index(">")
                currentLine = currentLine[currentLine.index(">")+1:]
                currentSeq = currentLine[:currentLine.index("<")]
                if len(cutResidues) > 0:
                    for i in range(len(cutResidues)):
                        target = int(cutResidues[i]) - i
                        currentSeq = currentSeq[:target] + currentSeq[target+1:]
                    NewCurrentSeq = currentSeq
                else:
                    NewCurrentSeq = currentSeq
                newAlignmentSeq = []
                for i in range(startPosition):
                    newAlignmentSeq.extend('-') 
                for i in range(len(NewCurrentSeq)):
                    newAlignmentSeq.extend(NewCurrentSeq[i])
                #for i in range(N - startPosition - len(currentSeq)):
                for i in range(N - endPosition - 1):
                    newAlignmentSeq.extend('-')
                    
            elif not gap == len(cutResidues):
                fail = 0
                gapCounter2 = 0
                line = f.next()
                if not "<Hsp_hseq>" in line:
                    print "Fail Hsp_hseq"
                currentLine = line
                currentLine = currentLine[currentLine.index(">")+1:]
                currentSeq = currentLine[:currentLine.index("<")]
                for i in range(len(cutResidues)):
                    target = int(cutResidues[i]) - i
                    currentSeq = currentSeq[:target] + currentSeq[target+1:]
                NewCurrentSeq = currentSeq
                for i in range(len(NewCurrentSeq)):
                    if NewCurrentSeq[i] == "-":
                        gapCounter2 = gapCounter2 + 1
                #if gap == len(cutResidues) + gapCounter2:
                #    print "EPIC FAIL AVERTED. ALL IS WELL."
                    
                if not gap == len(cutResidues) + gapCounter2:
                    fail = 1
                    print "FAIL IS STILL EPIC"
                    print startPosition
                    print endPosition
                    print gap
                    print len(cutResidues)
                    print gapCounter2
                    print NewCurrentSeq
                    print len(NewCurrentSeq)
                    print N
                newAlignmentSeq = []
                for i in range(startPosition):
                    newAlignmentSeq.extend('-') 
                for i in range(len(NewCurrentSeq)):
                    newAlignmentSeq.extend(NewCurrentSeq[i])
                #for i in range(N - startPosition - len(currentSeq)):
                for i in range(N - endPosition - 1):
                    newAlignmentSeq.extend('-')
                if fail == 2:
                    print len(newAlignmentSeq)
            Alignment.append(newAlignmentSeq)
    f.close()
    print "alignment length:", len(Alignment)
    return Alignment


#formDissimilarAlignmentMatrix( '1qleA', 538 )
def formDissimilarAlignmentMatrix( pdb, sequence_length ):
    alignment = formAlignmentMatrix( pdb, sequence_length )
    n = len(alignment)
    m = len(alignment[0])
    DissimilarAlignment = []
    d = len(DissimilarAlignment)
    for i in range(n):
        candidate = alignment[i]
        status = 1
        d = len(DissimilarAlignment)
        for j in range(d):
            if d == 0:
                DissimilarAlignment.append(candidate)
                break
            comparitiveSeq = DissimilarAlignment[j]
            counter = 0.0
            for k in range(m):
                if candidate[k] == comparitiveSeq[k]:
                    counter = counter + 1                
            #print counter
            #print counter/m
            #print m
            if counter/m > .8:
                status = 0
                break
            elif counter/m < .4:
                status = 0
                break
        if status == 1:
            DissimilarAlignment.append(candidate)
    print "Alignment Size:", n
    print "Dissimilar Alignment Size:",len(DissimilarAlignment)
    print "Sequence Length:", m

    return DissimilarAlignment













        
